﻿
SRT = LibStub("AceAddon-3.0"):NewAddon("SRT", "AceConsole-3.0", "AceEvent-3.0")
local L = LibStub("AceLocale-3.0"):GetLocale("SRT", true)
local LSM = LibStub("LibSharedMedia-3.0")
local deformatter = AceLibrary("Deformat-2.0")

function SRT:OnEnable()
end

function SRT:DeletePlayerData(player)
	if not player then return end
	
	for i,v in ipairs(self.db.global.players) do
		if v.player then
			if v.player == player then
				table.remove(self.db.global.players, i)
				break
			end
		end
	end
end

function SRT:PLAYER_ENTERING_WORLD(eventName, ...)
	SRT:UpdateRaidRoster()
	
	local function SRT_CHAT_MSG_SYSTEM_Filter(msg)
	if not msg then
		return false	
	end
	-- Trap rolls	
	local player, roll, minRoll, maxRoll = deformatter(msg, RANDOM_ROLL_RESULT)
		if player then
		
			if SRT:IsInRaid(player) == false then return false end
			
			roll = tonumber(roll)
			minRoll = tonumber(minRoll)
			maxRoll = tonumber(maxRoll)

			if not roll or not minRoll or not maxRoll
			or (minRoll ~= 1 or maxRoll ~= 100) then
				return
			end		

			
			--if not rollers then
				--rollers = {}			
			--end
			
			-- Ignore duplicate rolls.
			--for i, v in ipairs(rollers) do
				--if v.player == player then
					--SRT:Print(string.format("Duplicate roll detected for %s. Ignoring.", player))
					--return
				--end
			--end
							
			--if player == UnitName("player") then
			--	table.insert(rollers, {
			--		player = player,
			--		roll = roll,
			--		class = UnitClass("player") or "Unknown",
			--		level = UnitLevel("player") or -1,
			--	})			
			--else
			--	table.insert(rollers, {
			---		player = player,
			--		roll = roll,
			--		class = UnitClass(player) or "Unknown",
			--		level = UnitLevel(player) or -1,
			--	})			
			--	
			--end
			
			local data = SRT:GetPlayerData(player)			
			--SRT:Print(string.format("Recorded roll of %d for %s with priority of %d", roll, player, points))
			
			local output = string.format("%s | Rank: %s | Priority of %d", msg, data.guildRank, data.points)
			return false, output
			
		end
		
		return false;
	end

	ChatFrame_AddMessageEventFilter("CHAT_MSG_SYSTEM", SRT_CHAT_MSG_SYSTEM_Filter)
end


function SRT:COMBAT_LOG_EVENT_UNFILTERED(eventName, ...)	
	--local name, rank, icon, count, debuffType, duration, expirationTime	
	local timestamp, type, sourceGUID, sourceName, sourceFlags, destGUID, destName, destFlags, spellid, spellname, school, auratype, doseAmount = select(1, ...)
	--local currentUser = nil	
	
	if (type == "UNIT_DIED") then
		--SRT:Print(string.format("UNIT DIED: sourceName: %s, destGUID: %s, destName: %s", tostring(sourceName), tostring(destGUID), tostring(destName)))
	end
end

local displayCount

function SRT:CHAT_MSG_LOOT(eventName, ...)
	local arg1 = ...
	
	local raidCount = GetNumRaidMembers()
	
	-- Only track loot if we're looking at 25 man raids
	if raidCount < 15 then	return end
			
	local trackloot = true
	
	local loot_msg = string.gsub(LOOT_ITEM, "%.", "%%%.")
	loot_msg = string.gsub(loot_msg, "%%s", "(.*)")
	local name, item = string.match(arg1, loot_msg)	
	if (name == nil) then
		loot_msg = string.gsub(LOOT_ITEM_SELF, "%.", "%%%.")
		loot_msg = string.gsub(loot_msg, "%%s", "(.*)")
		item = string.match(arg1, loot_msg)
		name = UnitName("player");
	end
	if (item == nil) then return nil end
	local sName, sLink, iQuality, iLevel, iMinLevel, sType, sSubType, iCount, sEquipLoc, sTexture = GetItemInfo(item)
	
	local _, itemId, enchantId, jewelId1, jewelId2, jewelId3, jewelId4, suffixId, uniqueId = strsplit(":", item)

	
	--SRT:Print(string.format("LOOT DATA: LootedBy: %s, id: %s, name: %s, quality: %s, level: %s", name, tostring(itemId), sName, tostring(iQuality), tostring(iLevel)))
	
	if (iQuality < 4) then trackloot = false end
	
	
	-- check to see if we should ignore items
	for i,v in ipairs(self.db.global.ignoreditems) do
		if tonumber(itemId) == tonumber(v) then
			trackloot = false
			break
		end
	end	
	
	if trackloot == true then	
		--SRT:Print(string.format("LOOT DATA: LootedBy: %s, id: %s, name: %s, quality: %s, level: %s", name, tostring(itemId), sName, tostring(iQuality), tostring(iLevel)))
		if not displayCount then displayCount = 1 end
		StaticPopupDialogs["SRT_CONFIRM_SHARD"..displayCount] = {
							text = sLink.." was looted. Select 'OK' to update points or 'Sharded' if item was disenchanted or used for off-spec.",
							button1 = "OK",
							button2 = "Sharded",
							button3 = "Off Spec",
							OnAccept = function(data)											
											SRT:SetPointsAndLoot(data.data)
										end,
							OnCancel =	function(data)
											SRT:AddShardedItem()
										end,
							OnAlt =		function(data)
											data.data.offspec = true
											SRT:SetPointsAndLoot(data.data)
										end,
							timeout = 0,
							whileDead = 1,
							hideOnEscape = 0
						};
						
	   local dialog = StaticPopup_Show("SRT_CONFIRM_SHARD"..displayCount)    -- dialog contains the frame object
	   if(dialog) then		
		   dialog.data = { player = name, loot = { name = sName, itemID = itemId, }, offspec = false, }
	   end
	   displayCount = displayCount + 1	
	end
end

function SRT:ConfirmUpdateEndOfRaidPoints()
	StaticPopupDialogs["SRT_CONFIRM_EOR"] = {
					  text = "Are you sure you want to update end of raid points? This will increase the point value of all players who have been in this raid by one.",
					  button1 = "OK",
					  button2 = "Cancel",
					  OnAccept = function()
									SRT:UpdateEndOfRaidPoints()
					  end,
					  timeout = 0,
					  whileDead = 1,
					  hideOnEscape = 1
					};
	StaticPopup_Show("SRT_CONFIRM_EOR")
end

function SRT:UpdateEndOfRaidPoints()
	if not self.db.global.raidMembers then 
		SRT:Print("No raid members to update!")
		return
	end
	
	if not self.db.global.players then
		SRT:Print("No users in database!")
		return
	end
	
	SRT:UpdateGuildRank()
	
	local count = 0
	for x, y in ipairs(self.db.global.raidMembers) do
		for i, v in ipairs(self.db.global.players) do
			if v.player == y then
				v.points = v.points + 1				
				v.loot = {}
				v.lootCount = 0	
				v.startPoints= v.points							
				count = count + 1
			end
		end		
	end
	
	self.db.global.raidMembers = {}
	self.db.global.shardCount = 0
	self.db.global.lootCount = 0
	self.db.global.offsetCount = 0
	
	SRT:Print(string.format("Updated %d players!", count))
	SRT:CreateConfigMenu()
end

function SRT:ClearRaidData()
	for i,v in ipairs(self.db.global.players) do
		v.loot = {}
		v.lootCount = 0
		v.offspecCount = 0
	end
	
	self.db.global.shardCount = 0
	SRT:CreateConfigMenu()
end

function SRT:ResetAll()
	self.db.global = table.wipe(self.db.global)	
	SRT:SetDefaults()
	SRT:CreateConfigMenu();
end

function SRT:AddShardedItem()
	if not self.db.global.shardCount then
		self.db.global.shardCount = 1
	else
		self.db.global.shardCount = self.db.global.shardCount + 1
	end
	SRT:CreateConfigMenu()
end

function SRT:ManualSetPoints(player, points)
	-- make sure the player is in the database
	local getPoints = SRT:GetPoints(player)
	SRT:Print(string.format("Setting points for player %s to %d", player, tonumber(points)))
	
	for i,v in ipairs(self.db.global.players) do
		if v.player == player then			
			v.points = tonumber(points)
			v.startPoints = tonumber(points)
			break
		end
	end	
end

function SRT:SetPointsAndLoot(data)
	-- make sure player is in database
	local points = SRT:GetPoints(data.player)
	
	for i, v in ipairs(self.db.global.players) do
		if v.player == data.player then
			if data.offspec == false then
				v.points = -1
				table.insert(v.loot, loot)	
				v.lootCount = v.lootCount + 1			
				self.db.global.lootCount = self.db.global.lootCount + 1
				SRT:Print(string.format("Updated %s. Set priority to %d", v.player, tonumber(v.points)))
			else
				-- update global offset count				
				self.db.global.offsetCount = self.db.global.offsetCount + 1				
			end
			SRT:CreateConfigMenu()
			break
		end
	end
end

function SRT:DisplayPoints()
	for i, v in ipairs(self.db.global.players) do
		if v.player and v.points then	
			SRT:Print(string.format("%s - %d", v.player, v.points))			
		end
	end
end

function SRT:GetPoints(player)
	if not player then return 0 end
	
	for i, v in ipairs(self.db.global.players) do
		if v.player and v.points then
			if v.player == player then				
				return tonumber(v.points)				
			end
		end
	end		
	
	table.insert(self.db.global.players, { player = player, points = 0, loot = {}, lootCount = 0, startPoints = 0, guildRank = "App/Guest" })	
	SRT:UpdateGuildRank()
	
	return SRT:GetPoints(player)
end

function SRT:GetPlayerData(player)
	if not player then return 0 end
	
	for i, v in ipairs(self.db.global.players) do
		if v.player and v.points then
			if v.player == player then				
				return v
			end
		end
	end		
	
	table.insert(self.db.global.players, { player = player, points = 0, loot = {}, lootCount = 0, startPoints = 0, guildRank = "App/Guest" })	
	SRT:UpdateGuildRank()
	
	return SRT:GetPlayerData(player)
end

local rollers

function SRT:ResetRolls()
	rollers = {}
end


function SRT:RAID_ROSTER_UPDATE(event, ...)
	SRT:UpdateRaidRoster();
end

function SRT:UpdateRaidRoster()
	if not UnitInRaid("player") then return end
	
	
	if not self.db.global.raidMembers then self.db.global.raidMembers = {} end	
	local found = false;	
	local raidCount = GetNumRaidMembers()	
	
	if raidCount == 0 then return end
	if raidCount < 15 then return end
	
	for i=1,raidCount,1 do
		local name, rank, subgroup, level, class, fileName, zone, online, isDead, role, isML = GetRaidRosterInfo(i);
		if name then						
			
			-- see if the player is already in this raids list.
			found = false
			for i, v in ipairs(self.db.global.raidMembers) do
				if v == name then
					found = true
					break
				end
			end
			
			if (found == false) then			
				table.insert(self.db.global.raidMembers, name)			
			end
			
			-- check to see if they are in the database by getting their points
			SRT:GetPoints(name)								
		end			
	end
	
	SRT:CreateConfigMenu()
end

function SRT:UpdateGuildRank()	
	GuildRoster()
	
	local guildCount = GetNumGuildMembers(true)	
	if guildCount == 0 then return end
	
	local guildInfo = {}	
	
	for i=1,guildCount,1 do
		local name, rank, rankIndex, level, class, zone, note, officernote, online, status = GetGuildRosterInfo(i);
		guildInfo[name] = rank;		
	end
	
	for i,v in ipairs(self.db.global.players) do
		if v.player then
			if guildInfo[v.player] then
				v.guildRank = guildInfo[v.player];
			else
				v.guildRank = "App/Guest"
			end
		end
	end
end

function SRT:ExportPointsData(type, showNextRaid)
	if not type then return end
	local output
	local itemTemp
		
	output = "[table][tr][td][b]Raider[/b][/td][td][b]Rank[/b][/td][td][b]Start Priority[/b][/td]"
	if showNextRaid then
		output = output .. "[td][b]# Pieces Loot[/b][/td][td][b]Next Raid Priority[/b][/td]"
	end
	output = output .. "[/tr]";
	
	table.sort(self.db.global.players, function(a, b) return a.player < b.player end)
	
	for i,v in ipairs(self.db.global.players) do
		if v.player and v.points then					
			output = output .. string.format("[tr][td]%s[/td][td]%s[/td][td]%d[/td]", v.player, v.guildRank, v.startPoints)
			if showNextRaid then
				local nextPoints = v.points
				if SRT:IsInRaidMembersList(v.player) == true then nextPoints = nextPoints + 1 end
				output = output .. string.format("[td]%d[/td][td]%d[/td]", v.lootCount, nextPoints)
			end
			output = output .. "[/tr]";
			--output = output .. "[tr][td]" .. v.player .. "[/td][td]" .. v.startPoints .. "[/td][td]" .. v.lootCount .. "[/td][td]";
			--itemtemp = ""
			--if v.lastLoot then 
			--	for x,y in ipairs(v.loot) do
			--		if y.itemId then
			--			itemTemp = itemTemp .. "[item]" .. tostring(y.itemId) .. "[/item]"
			--		end
			--	end
			--end
			--output = output .. itemTemp .. "[/td][td]" .. v.points + 1 .. "[/tr]";
		end
	end
	
	output = output .. "[/table]"
	
	if snowNextRaid then
		output = output .. "[table][tr][td]Pieces Sharded[/td][td]" .. self.db.global.shardCount .. "[/td][/tr]"
		output = output .. "[tr][td]Pieces to Offspec[/td][td]" .. self.db.global.offsetCount .. "[/td][/tr]"
		output = output .. "[tr][td]Total Upgrades[/td][td]" .. self.db.global.lootCount .. "[/td][/tr]"
		output = output .. "[tr][td]Total Loot[/td][td]" .. self.db.global.lootCount + self.db.global.offsetCount + self.db.global.shardCount .. "[/td][/tr]"
		output = output .. "[/table]";
	end
		
	
	if tostring(type) == "html" then		
		output = string.gsub(output, "%[", "<")
		output = string.gsub(output, "%]", ">")	
	end
	
	return output
end

function SRT:IsInRaidMembersList(player)
	if not player then return end
	
	for i,v in ipairs(self.db.global.raidMembers) do
		if v then
			if v == player then return true end
		end
	end
	
	return false
end

function SRT:IsInRaid(player)	
	if not UnitInRaid("player") then return false end
	
	if player == UnitName("player") then
		if UnitInRaid("player") then return true end
	end
	
	local raidCount = GetNumRaidMembers()
		
	if raidCount == 0 then return false end
	
	for i=1,raidCount,1 do
		local name, rank, subgroup, level, class, fileName, zone, online, isDead, role, isML = GetRaidRosterInfo(i);
		if name then
			if tostring(name) == tostring(player) then
				return true
			end
		end
	end
	
	return false	
end

function SRT:AddGuildMembers()
	local numGuildMembers = GetNumGuildMembers(true);
	
	for i=1,numGuildMembers,1 do
		local name, rank, rankIndex, level, class, zone, note, officernote, online, status = GetGuildRosterInfo(i);
		if online then
			SRT:Print(string.format("Found %s Online!", name))
			if level == 80 then
				SRT:GetPoints(name)
			end
		end
	end
	
	SRT:Print("Added online guild members to points list")
	SRT:CreateConfigMenu()
end

function SRT:DisplayCurRaidMembers()
	if self.db.global.raidMembers then
		SRT:Print("Current Raid Members List")
		for i,v in ipairs(self.db.global.raidMembers) do
			SRT:Print(v)
		end
	else
		SRT:Print("No current raid members!")
	end
end

function SRT:OnInitialize()
    self.db = LibStub("AceDB-3.0"):New("SRTDB")
    
    SRT:SetDefaults()

	if UnitInRaid("player") then self.db.global.isInRaid = true else self.db.global.isInRaid = false end
	    
    SRT:CreateConfigMenu()
  -- Code that you want to run when the addon is first loaded goes here.
end

function SRT:SetDefaults()
	if not self.db.global.ignoreditems then
		self.db.global.ignoreditems = {}
		table.insert(self.db.global.ignoreditems, 43345)
		table.insert(self.db.global.ignoreditems, 43346)
		table.insert(self.db.global.ignoreditems, 43347)
		table.insert(self.db.global.ignoreditems, 40752)
		table.insert(self.db.global.ignoreditems, 40753)
		table.insert(self.db.global.ignoreditems, 34057)
	end	
	
	-- make sure our data exists
	if not self.db.global.lootCount then self.db.global.lootCount = 0 end
	if not self.db.global.offsetCount then self.db.global.offsetCount = 0 end
	if not self.db.global.players then self.db.global.players = {} end
	if not self.db.global.raidMembers then self.db.global.raidMembers = {} end
	if not self.db.global.shardCount then self.db.global.shardCount = 0 end
	
	for i, v in ipairs(self.db.global.players) do
		if not v.points then v.points = 0 end
		if not v.loot then v.loot = {} end
		if not v.lootCount then v.lootCount = 0 end
		if not v.startPoints then 
			v.startPoints = 0 
			v.startPoints = v.points
		end	
		if not v.guildRank then	v.guildRank = "App/Guest" end		
	end
	
	SRT:UpdateGuildRank()
end

function SRT:OnEnable()
    -- Called when the addon is enabled
    self.selfGUID = UnitGUID("player")

    local localizedClass, englishClass = UnitClass("player");
	self.PlayerClass = englishClass	
	
    
    SRT:RegisterEvent("PLAYER_ENTERING_WORLD")
    --SRT:RegisterEvent("COMBAT_LOG_EVENT_UNFILTERED")
    SRT:RegisterEvent("CHAT_MSG_LOOT")
    --SRT:RegisterEvent("CHAT_MSG_SYSTEM")
    SRT:RegisterEvent("RAID_ROSTER_UPDATE")
    
  
end

function SRT:OnDisable()
    -- Called when the addon is disabled
end
